Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision a41623dd1e56318466dc81751481d37d19489c7b)
+++ kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
@@ -32,94 +32,108 @@
 #define BUCKETS_FOR_NORO_RED 1
 #define SR_HDL(A) ((long)(A))
-static const int bundle_size=100;
-static const int bundle_size_noro=10000;
-static const int delay_factor=3;
-int QlogSize(number n);
+static const int bundle_size = 100;
+static const int bundle_size_noro = 10000;
+static const int delay_factor = 3;
+int QlogSize (number n);
 #define ADD_LATER_SIZE 500
 #if 1
-static omBin lm_bin=NULL;
-
-static void simplify_poly(poly p, ring r)
-{
-     assume(r==currRing);
-     if (!rField_is_Zp(r))
-     {
-        p_Cleardenom(p,r);
-        //p_Content(p,r); //is a duplicate call, but belongs here
-     }
-     else
-       pNorm(p);
-}
+static omBin lm_bin = NULL;
+
+static void
+simplify_poly (poly p, ring r)
+{
+  assume (r == currRing);
+  if (!rField_is_Zp (r))
+  {
+    p_Cleardenom (p, r);
+    //p_Content(p,r); //is a duplicate call, but belongs here
+  }
+  else
+    pNorm (p);
+}
+
 //static const BOOLEAN up_to_radical=TRUE;
 
-int slim_nsize(number n, ring r)
-{
-  if (rField_is_Zp(r))
+int
+slim_nsize (number n, ring r)
+{
+  if (rField_is_Zp (r))
   {
     return 1;
   }
-  if (rField_is_Q(r))
-  {
-    return QlogSize(n);
+  if (rField_is_Q (r))
+  {
+    return QlogSize (n);
   }
   else
   {
-    return n_Size(n,r);
-  }
-}
-static BOOLEAN monomial_root(poly m, ring r)
-{
-    BOOLEAN changed=FALSE;
-    int i;
-    for(i=1;i<=rVar(r);i++)
-    {
-        int e=p_GetExp(m,i,r);
-        if (e>1)
-        {
-            p_SetExp(m,i,1,r);
-            changed=TRUE;
-        }
-    }
-    if (changed) {
-        p_Setm(m,r);
-    }
-    return changed;
-}
-static BOOLEAN polynomial_root(poly h, ring r)
-{
-  poly got=gcd_of_terms(h,r);
-  BOOLEAN changed=FALSE;
-  if((got!=NULL) &&(TEST_V_UPTORADICAL)) {
-    poly copy=p_Copy(got,r);
+    return n_Size (n, r);
+  }
+}
+
+static BOOLEAN
+monomial_root (poly m, ring r)
+{
+  BOOLEAN changed = FALSE;
+  int i;
+  for (i = 1; i <= rVar (r); i++)
+  {
+    int e = p_GetExp (m, i, r);
+    if (e > 1)
+    {
+      p_SetExp (m, i, 1, r);
+      changed = TRUE;
+    }
+  }
+  if (changed)
+  {
+    p_Setm (m, r);
+  }
+  return changed;
+}
+
+static BOOLEAN
+polynomial_root (poly h, ring r)
+{
+  poly got = gcd_of_terms (h, r);
+  BOOLEAN changed = FALSE;
+  if ((got != NULL) && (TEST_V_UPTORADICAL))
+  {
+    poly copy = p_Copy (got, r);
     //p_wrp(got,c->r);
-    changed=monomial_root(got,r);
+    changed = monomial_root (got, r);
     if (changed)
     {
-         poly div_by=pDivide(copy, got);
-         poly iter=h;
-         while(iter)
-         {
-            pExpVectorSub(iter,div_by);
-            pIter(iter);
-         }
-         p_Delete(&div_by, r);
-         if (TEST_OPT_PROT)
-             PrintS("U");
-    }
-    p_Delete(&copy,r);
-  }
-  p_Delete(&got,r);
+      poly div_by = pDivide (copy, got);
+      poly iter = h;
+      while (iter)
+      {
+	pExpVectorSub (iter, div_by);
+	pIter (iter);
+      }
+      p_Delete (&div_by, r);
+      if (TEST_OPT_PROT)
+	PrintS ("U");
+    }
+    p_Delete (&copy, r);
+  }
+  p_Delete (&got, r);
   return changed;
 }
-static inline poly p_Init_Special(const ring r)
-{
-  return p_Init(r,lm_bin);
-}
-static inline poly pOne_Special(const ring r=currRing)
-{
-  poly rc = p_Init_Special(r);
-  pSetCoeff0(rc,n_Init(1,r));
+
+static inline poly
+p_Init_Special (const ring r)
+{
+  return p_Init (r, lm_bin);
+}
+
+static inline poly
+pOne_Special (const ring r = currRing)
+{
+  poly rc = p_Init_Special (r);
+  pSetCoeff0 (rc, n_Init (1, r));
   return rc;
 }
+
 // zum Initialiseren: in t_rep_gb plazieren:
 
@@ -133,24 +147,39 @@
 #ifdef LEN_VAR1
 // erste Variante: Laenge: Anzahl der Monome
-static inline int pSLength(poly p, int l) { return l; }
-static inline int kSBucketLength(kBucket* bucket, poly lm)
-  {return bucket_guess(bucket);}
+static inline int
+pSLength (poly p, int l)
+{
+  return l;
+}
+
+static inline int
+kSBucketLength (kBucket * bucket, poly lm)
+{
+  return bucket_guess (bucket);
+}
 #endif
 
 #ifdef LEN_VAR2
 // 2. Variante: Laenge: Platz fuer die Koeff.
-int pSLength(poly p,int l)
-{
-  int s=0;
-  while (p!=NULL) { s+=nSize(pGetCoeff(p));pIter(p); }
+int
+pSLength (poly p, int l)
+{
+  int s = 0;
+  while (p != NULL)
+  {
+    s += nSize (pGetCoeff (p));
+    pIter (p);
+  }
   return s;
 }
-int kSBucketLength(kBucket* b, poly lm)
-{
-  int s=0;
+
+int
+kSBucketLength (kBucket * b, poly lm)
+{
+  int s = 0;
   int i;
-  for (i=MAX_BUCKET;i>=0;i--)
-  {
-    s+=pSLength(b->buckets[i],0);
+  for (i = MAX_BUCKET; i >= 0; i--)
+  {
+    s += pSLength (b->buckets[i], 0);
   }
   return s;
@@ -158,96 +187,101 @@
 #endif
 
-int QlogSize(number n)
-{
-    if (SR_HDL(n) & SR_INT)
-    {
-       long i=SR_TO_INT(n);
-       if (i==0) return 0;
-
-       unsigned long v;
-       v=(i>=0)?i:-i;
-       int r = 0;
-
-       while (v >>= 1)
-       {
-        r++;
-       }
-       return r+1;
-    }
-    //assume denominator is 0
-    return mpz_sizeinbase(n->z,2);
+int
+QlogSize (number n)
+{
+  if (SR_HDL (n) & SR_INT)
+  {
+    long i = SR_TO_INT (n);
+    if (i == 0)
+      return 0;
+
+    unsigned long v;
+    v = (i >= 0) ? i : -i;
+    int r = 0;
+
+    while (v >>= 1)
+    {
+      r++;
+    }
+    return r + 1;
+  }
+  //assume denominator is 0
+  return mpz_sizeinbase (n->z, 2);
 }
 
 #ifdef LEN_VAR3
-static inline wlen_type pSLength(poly p,int l)
+static inline wlen_type
+pSLength (poly p, int l)
 {
   wlen_type c;
-  number coef=pGetCoeff(p);
-  if (rField_is_Q(currRing))
-  {
-    c=QlogSize(coef);
+  number coef = pGetCoeff (p);
+  if (rField_is_Q (currRing))
+  {
+    c = QlogSize (coef);
   }
   else
-    c=nSize(coef);
+    c = nSize (coef);
   if (!(TEST_V_COEFSTRAT))
-      return (wlen_type)c*(wlen_type)l /*pLength(p)*/;
+    return (wlen_type) c *(wlen_type) l /*pLength(p) */ ;
   else
   {
-    wlen_type res=l;
-    res*=c;
-    res*=c;
+    wlen_type res = l;
+    res *= c;
+    res *= c;
     return res;
   }
 }
+
 //! TODO CoefBuckets bercksichtigen
-wlen_type kSBucketLength(kBucket* b, poly lm=NULL)
-{
-  int s=0;
+wlen_type
+kSBucketLength (kBucket * b, poly lm = NULL)
+{
+  int s = 0;
   wlen_type c;
   number coef;
-  if(lm==NULL)
-    coef=pGetCoeff(kBucketGetLm(b));
-    //c=nSize(pGetCoeff(kBucketGetLm(b)));
+  if (lm == NULL)
+    coef = pGetCoeff (kBucketGetLm (b));
+  //c=nSize(pGetCoeff(kBucketGetLm(b)));
   else
-    coef=pGetCoeff(lm);
-    //c=nSize(pGetCoeff(lm));
-  if (rField_is_Q(currRing))
-  {
-    c=QlogSize(coef);
+    coef = pGetCoeff (lm);
+  //c=nSize(pGetCoeff(lm));
+  if (rField_is_Q (currRing))
+  {
+    c = QlogSize (coef);
   }
   else
-    c=nSize(coef);
+    c = nSize (coef);
 
   int i;
-  for (i=b->buckets_used;i>=0;i--)
-  {
-    assume((b->buckets_length[i]==0)||(b->buckets[i]!=NULL));
-    s+=b->buckets_length[i] /*pLength(b->buckets[i])*/;
-  }
-  #ifdef HAVE_COEF_BUCKETS
-  assume(b->buckets[0]==kBucketGetLm(b));
-  if (b->coef[0]!=NULL)
-  {
-    if (rField_is_Q(currRing))
-    {
-      int modifier=QlogSize(pGetCoeff(b->coef[0]));
-      c+=modifier;
+  for (i = b->buckets_used; i >= 0; i--)
+  {
+    assume ((b->buckets_length[i] == 0) || (b->buckets[i] != NULL));
+    s += b->buckets_length[i] /*pLength(b->buckets[i]) */ ;
+  }
+#ifdef HAVE_COEF_BUCKETS
+  assume (b->buckets[0] == kBucketGetLm (b));
+  if (b->coef[0] != NULL)
+  {
+    if (rField_is_Q (currRing))
+    {
+      int modifier = QlogSize (pGetCoeff (b->coef[0]));
+      c += modifier;
     }
     else
     {
-      int modifier=nSize(pGetCoeff(b->coef[0]));
-      c*=modifier;
-    }
-  }
-  #endif
+      int modifier = nSize (pGetCoeff (b->coef[0]));
+      c *= modifier;
+    }
+  }
+#endif
   if (!(TEST_V_COEFSTRAT))
   {
-    return s*c;
+    return s * c;
   }
   else
   {
-    wlen_type res=s;
-    res*=c;
-    res*=c;
+    wlen_type res = s;
+    res *= c;
+    res *= c;
     return res;
   }
@@ -255,64 +289,68 @@
 #endif
 #ifdef LEN_VAR5
-static inline wlen_type pSLength(poly p,int l)
+static inline wlen_type
+pSLength (poly p, int l)
 {
   int c;
-  number coef=pGetCoeff(p);
-  if (rField_is_Q(currRing))
-  {
-    c=QlogSize(coef);
+  number coef = pGetCoeff (p);
+  if (rField_is_Q (currRing))
+  {
+    c = QlogSize (coef);
   }
   else
-    c=nSize(coef);
-  wlen_type erg=l;
-  erg*=c;
-  erg*=c;
+    c = nSize (coef);
+  wlen_type erg = l;
+  erg *= c;
+  erg *= c;
   //PrintS("lenvar 5");
-  assume(erg>=0);
-  return erg; /*pLength(p)*/;
-}
+  assume (erg >= 0);
+  return erg; /*pLength(p) */ ;
+}
+
 //! TODO CoefBuckets bercksichtigen
-wlen_type kSBucketLength(kBucket* b, poly lm=NULL)
-{
-  wlen_type s=0;
+wlen_type
+kSBucketLength (kBucket * b, poly lm = NULL)
+{
+  wlen_type s = 0;
   int c;
   number coef;
-  if(lm==NULL)
-    coef=pGetCoeff(kBucketGetLm(b));
-    //c=nSize(pGetCoeff(kBucketGetLm(b)));
+  if (lm == NULL)
+    coef = pGetCoeff (kBucketGetLm (b));
+  //c=nSize(pGetCoeff(kBucketGetLm(b)));
   else
-    coef=pGetCoeff(lm);
-    //c=nSize(pGetCoeff(lm));
-  if (rField_is_Q(currRing))
-  {
-    c=QlogSize(coef);
+    coef = pGetCoeff (lm);
+  //c=nSize(pGetCoeff(lm));
+  if (rField_is_Q (currRing))
+  {
+    c = QlogSize (coef);
   }
   else
-    c=nSize(coef);
+    c = nSize (coef);
 
   int i;
-  for (i=b->buckets_used;i>=0;i--)
-  {
-    assume((b->buckets_length[i]==0)||(b->buckets[i]!=NULL));
-    s+=b->buckets_length[i] /*pLength(b->buckets[i])*/;
-  }
-  #ifdef HAVE_COEF_BUCKETS
-  assume(b->buckets[0]==kBucketGetLm(b));
-  if (b->coef[0]!=NULL)
-  {
-    if (rField_is_Q(currRing))
-    {
-      int modifier=QlogSize(pGetCoeff(b->coef[0]));
-      c+=modifier;
+  for (i = b->buckets_used; i >= 0; i--)
+  {
+    assume ((b->buckets_length[i] == 0) || (b->buckets[i] != NULL));
+    s += b->buckets_length[i] /*pLength(b->buckets[i]) */ ;
+  }
+#ifdef HAVE_COEF_BUCKETS
+  assume (b->buckets[0] == kBucketGetLm (b));
+  if (b->coef[0] != NULL)
+  {
+    if (rField_is_Q (currRing))
+    {
+      int modifier = QlogSize (pGetCoeff (b->coef[0]));
+      c += modifier;
     }
     else
     {
-      int modifier=nSize(pGetCoeff(b->coef[0]));
-      c*=modifier;}
-    }
-  #endif
-  wlen_type erg=s;
-  erg*=c;
-  erg*=c;
+      int modifier = nSize (pGetCoeff (b->coef[0]));
+      c *= modifier;
+    }
+  }
+#endif
+  wlen_type erg = s;
+  erg *= c;
+  erg *= c;
   return erg;
 }
@@ -321,382 +359,438 @@
 #ifdef LEN_VAR4
 // 4.Variante: Laenge: Platz fuer Leitk * (1+Platz fuer andere Koeff.)
-int pSLength(poly p, int l)
-{
-  int s=1;
-  int c=nSize(pGetCoeff(p));
-  pIter(p);
-  while (p!=NULL) { s+=nSize(pGetCoeff(p));pIter(p); }
-  return s*c;
-}
-int kSBucketLength(kBucket* b)
-{
-  int s=1;
-  int c=nSize(pGetCoeff(kBucketGetLm(b)));
+int
+pSLength (poly p, int l)
+{
+  int s = 1;
+  int c = nSize (pGetCoeff (p));
+  pIter (p);
+  while (p != NULL)
+  {
+    s += nSize (pGetCoeff (p));
+    pIter (p);
+  }
+  return s * c;
+}
+
+int
+kSBucketLength (kBucket * b)
+{
+  int s = 1;
+  int c = nSize (pGetCoeff (kBucketGetLm (b)));
   int i;
-  for (i=MAX_BUCKET;i>0;i--)
-  {
-    if(b->buckets[i]==NULL) continue;
-    s+=pSLength(b->buckets[i],0);
-  }
-  return s*c;
+  for (i = MAX_BUCKET; i > 0; i--)
+  {
+    if (b->buckets[i] == NULL)
+      continue;
+    s += pSLength (b->buckets[i], 0);
+  }
+  return s * c;
 }
 #endif
 //BUG/TODO this stuff will fail on internal Schreyer orderings
-static BOOLEAN elength_is_normal_length(poly p, slimgb_alg* c)
-{
-    ring r=c->r;
-    if (p_GetComp(p,r)!=0) return FALSE;
-    if (c->lastDpBlockStart<=pVariables)
-    {
-        int i;
-        for(i=1;i<c->lastDpBlockStart;i++)
-        {
-            if (p_GetExp(p,i,r)!=0)
-            {
-                break;
-            }
-        }
-        if (i>=c->lastDpBlockStart) {
-        //wrp(p);
-        //PrintS("\n");
-        return TRUE;
-        }
-        else return FALSE;
+static BOOLEAN
+elength_is_normal_length (poly p, slimgb_alg * c)
+{
+  ring r = c->r;
+  if (p_GetComp (p, r) != 0)
+    return FALSE;
+  if (c->lastDpBlockStart <= pVariables)
+  {
+    int i;
+    for (i = 1; i < c->lastDpBlockStart; i++)
+    {
+      if (p_GetExp (p, i, r) != 0)
+      {
+	break;
+      }
+    }
+    if (i >= c->lastDpBlockStart)
+    {
+      //wrp(p);
+      //PrintS("\n");
+      return TRUE;
     }
     else
+      return FALSE;
+  }
+  else
     return FALSE;
 }
 
-static BOOLEAN lies_in_last_dp_block(poly p, slimgb_alg* c)
-{
-    ring r=c->r;
-    if (p_GetComp(p,r)!=0) return FALSE;
-    if (c->lastDpBlockStart<=pVariables)
-    {
-        int i;
-        for(i=1;i<c->lastDpBlockStart;i++)
-        {
-            if (p_GetExp(p,i,r)!=0)
-            {
-                break;
-            }
-        }
-        if (i>=c->lastDpBlockStart) {
-        //wrp(p);
-        //PrintS("\n");
-        return TRUE;
-        }
-        else return FALSE;
+static BOOLEAN
+lies_in_last_dp_block (poly p, slimgb_alg * c)
+{
+  ring r = c->r;
+  if (p_GetComp (p, r) != 0)
+    return FALSE;
+  if (c->lastDpBlockStart <= pVariables)
+  {
+    int i;
+    for (i = 1; i < c->lastDpBlockStart; i++)
+    {
+      if (p_GetExp (p, i, r) != 0)
+      {
+	break;
+      }
+    }
+    if (i >= c->lastDpBlockStart)
+    {
+      //wrp(p);
+      //PrintS("\n");
+      return TRUE;
     }
     else
+      return FALSE;
+  }
+  else
     return FALSE;
 }
 
-static int get_last_dp_block_start(ring r)
-{
-    //ring r=c->r;
-    int last_block;
-
-    if (rRing_has_CompLastBlock(r))
-    {
-        last_block=rBlocks(r) - 3;
-    }
-    else
-    {last_block=rBlocks(r)-2;}
-    assume(last_block>=0);
-    if (r->order[last_block]==ringorder_dp)
-        return r->block0[last_block];
-    return pVariables+1;
-}
-
-static wlen_type do_pELength(poly p, slimgb_alg* c, int dlm=-1)
-{
-  if(p==NULL) return 0;
-  wlen_type s=0;
-  poly pi=p;
-  if(dlm<0)
-  {
-    dlm=c->pTotaldegree(p);
-    s=1;
-    pi=p->next;
-  }
-
-  while(pi)
-  {
-    int d=c->pTotaldegree(pi);
-    if(d>dlm)
-      s+=1+d-dlm;
+static int
+get_last_dp_block_start (ring r)
+{
+  //ring r=c->r;
+  int last_block;
+
+  if (rRing_has_CompLastBlock (r))
+  {
+    last_block = rBlocks (r) - 3;
+  }
+  else
+  {
+    last_block = rBlocks (r) - 2;
+  }
+  assume (last_block >= 0);
+  if (r->order[last_block] == ringorder_dp)
+    return r->block0[last_block];
+  return pVariables + 1;
+}
+
+static wlen_type
+do_pELength (poly p, slimgb_alg * c, int dlm = -1)
+{
+  if (p == NULL)
+    return 0;
+  wlen_type s = 0;
+  poly pi = p;
+  if (dlm < 0)
+  {
+    dlm = c->pTotaldegree (p);
+    s = 1;
+    pi = p->next;
+  }
+
+  while (pi)
+  {
+    int d = c->pTotaldegree (pi);
+    if (d > dlm)
+      s += 1 + d - dlm;
     else
       ++s;
-    pi=pi->next;
+    pi = pi->next;
   }
   return s;
 }
 
-wlen_type pELength(poly p, slimgb_alg* c, ring r)
-{
-  if(p==NULL) return 0;
-  wlen_type s=0;
-  poly pi=p;
+wlen_type
+pELength (poly p, slimgb_alg * c, ring r)
+{
+  if (p == NULL)
+    return 0;
+  wlen_type s = 0;
+  poly pi = p;
   int dlm;
-  dlm=c->pTotaldegree(p);
-  s=1;
-  pi=p->next;
-
-  while(pi)
-  {
-    int d=c->pTotaldegree(pi);
-    if(d>dlm)
-      s+=1+d-dlm;
+  dlm = c->pTotaldegree (p);
+  s = 1;
+  pi = p->next;
+
+  while (pi)
+  {
+    int d = c->pTotaldegree (pi);
+    if (d > dlm)
+      s += 1 + d - dlm;
     else
       ++s;
-    pi=pi->next;
+    pi = pi->next;
   }
   return s;
 }
 
-wlen_type kEBucketLength(kBucket* b, poly lm,int sugar,slimgb_alg* ca)
-{
-  wlen_type s=0;
-  if(lm==NULL)
-  {
-    lm=kBucketGetLm(b);
-  }
-  if(lm==NULL) return 0;
-  if(elength_is_normal_length(lm,ca))
-  {
-    return bucket_guess(b);
-  }
-  int d=ca->pTotaldegree(lm);
-  #if 0
-  assume(sugar>=d);
-  s=1+(bucket_guess(b)-1)*(sugar-d+1);
+wlen_type
+kEBucketLength (kBucket * b, poly lm, int sugar, slimgb_alg * ca)
+{
+  wlen_type s = 0;
+  if (lm == NULL)
+  {
+    lm = kBucketGetLm (b);
+  }
+  if (lm == NULL)
+    return 0;
+  if (elength_is_normal_length (lm, ca))
+  {
+    return bucket_guess (b);
+  }
+  int d = ca->pTotaldegree (lm);
+#if 0
+  assume (sugar >= d);
+  s = 1 + (bucket_guess (b) - 1) * (sugar - d + 1);
   return s;
-  #else
+#else
 
   //int d=pTotaldegree(lm,ca->r);
   int i;
-  for (i=b->buckets_used;i>=0;i--)
-  {
-    if(b->buckets[i]==NULL) continue;
-
-    if ((ca->pTotaldegree(b->buckets[i])<=d) &&(elength_is_normal_length(b->buckets[i],ca)))
-    {
-        s+=b->buckets_length[i];
+  for (i = b->buckets_used; i >= 0; i--)
+  {
+    if (b->buckets[i] == NULL)
+      continue;
+
+    if ((ca->pTotaldegree (b->buckets[i]) <= d)
+	&& (elength_is_normal_length (b->buckets[i], ca)))
+    {
+      s += b->buckets_length[i];
     }
     else
     {
-    s+=do_pELength(b->buckets[i],ca,d);
+      s += do_pELength (b->buckets[i], ca, d);
     }
   }
   return s;
-  #endif
-}
-
-static inline int pELength(poly p, slimgb_alg* c,int l)
-{
-  if (p==NULL) return 0;
-  if ((l>0) &&(elength_is_normal_length(p,c)))
+#endif
+}
+
+static inline int
+pELength (poly p, slimgb_alg * c, int l)
+{
+  if (p == NULL)
+    return 0;
+  if ((l > 0) && (elength_is_normal_length (p, c)))
     return l;
-  return do_pELength(p,c);
-}
-
-static inline wlen_type pQuality(poly p, slimgb_alg* c, int l=-1)
-{
-  if(l<0)
-    l=pLength(p);
-  if(c->isDifficultField) {
-    if(c->eliminationProblem)
+  return do_pELength (p, c);
+}
+
+static inline wlen_type
+pQuality (poly p, slimgb_alg * c, int l = -1)
+{
+  if (l < 0)
+    l = pLength (p);
+  if (c->isDifficultField)
+  {
+    if (c->eliminationProblem)
     {
       wlen_type cs;
-      number coef=pGetCoeff(p);
-      if (rField_is_Q(currRing))
-      {
-         cs=QlogSize(coef);
+      number coef = pGetCoeff (p);
+      if (rField_is_Q (currRing))
+      {
+	cs = QlogSize (coef);
       }
       else
-        cs=nSize(coef);
-     wlen_type erg=cs;
-     if(TEST_V_COEFSTRAT)
-        erg*=cs;
-     //erg*=cs;//for quadratic
-     erg*=pELength(p,c,l);
-    //FIXME: not quadratic coeff size
+	cs = nSize (coef);
+      wlen_type erg = cs;
+      if (TEST_V_COEFSTRAT)
+	erg *= cs;
+      //erg*=cs;//for quadratic
+      erg *= pELength (p, c, l);
+      //FIXME: not quadratic coeff size
       //return cs*pELength(p,c,l);
       return erg;
     }
     //PrintS("I am here");
-    wlen_type r=pSLength(p,l);
-    assume(r>=0);
+    wlen_type r = pSLength (p, l);
+    assume (r >= 0);
     return r;
   }
-  if(c->eliminationProblem) return pELength(p,c,l);
+  if (c->eliminationProblem)
+    return pELength (p, c, l);
   return l;
 }
 
-static inline int pTotaldegree_full(poly p)
-{
-  int r=0;
-  while(p)
-  {
-    int d=pTotaldegree(p);
-    r=si_max(r,d);
-    pIter(p);
+static inline int
+pTotaldegree_full (poly p)
+{
+  int r = 0;
+  while (p)
+  {
+    int d = pTotaldegree (p);
+    r = si_max (r, d);
+    pIter (p);
   }
   return r;
 }
 
-wlen_type red_object::guess_quality(slimgb_alg* c)
-{
-    //works at the moment only for lenvar 1, because in different
-    //case, you have to look on coefs
-    wlen_type s=0;
-    if (c->isDifficultField)
-    {
-      //s=kSBucketLength(bucket,this->p);
-      if(c->eliminationProblem)
-      {
-    wlen_type cs;
-    number coef;
-
-    coef=pGetCoeff(kBucketGetLm(bucket));
-    //c=nSize(pGetCoeff(kBucketGetLm(b)));
-
-    //c=nSize(pGetCoeff(lm));
-    if (rField_is_Q(currRing))
-    {
-      cs=QlogSize(coef);
-    }
+wlen_type
+red_object::guess_quality (slimgb_alg * c)
+{
+  //works at the moment only for lenvar 1, because in different
+  //case, you have to look on coefs
+  wlen_type s = 0;
+  if (c->isDifficultField)
+  {
+    //s=kSBucketLength(bucket,this->p);
+    if (c->eliminationProblem)
+    {
+      wlen_type cs;
+      number coef;
+
+      coef = pGetCoeff (kBucketGetLm (bucket));
+      //c=nSize(pGetCoeff(kBucketGetLm(b)));
+
+      //c=nSize(pGetCoeff(lm));
+      if (rField_is_Q (currRing))
+      {
+	cs = QlogSize (coef);
+      }
+      else
+	cs = nSize (coef);
+#ifdef HAVE_COEF_BUCKETS
+      if (bucket->coef[0] != NULL)
+      {
+	if (rField_is_Q (currRing))
+	{
+	  int modifier = QlogSize (pGetCoeff (bucket->coef[0]));
+	  cs += modifier;
+	}
+	else
+	{
+	  int modifier = nSize (pGetCoeff (bucket->coef[0]));
+	  cs *= modifier;
+	}
+      }
+#endif
+      //FIXME:not quadratic
+      wlen_type erg = kEBucketLength (this->bucket, this->p, this->sugar, c);
+      //erg*=cs;//for quadratic
+      erg *= cs;
+      if (TEST_V_COEFSTRAT)
+	erg *= cs;
+      //return cs*kEBucketLength(this->bucket,this->p,c);
+      return erg;
+    }
+    s = kSBucketLength (bucket, NULL);
+  }
+  else
+  {
+    if (c->eliminationProblem)
+      //if (false)
+      s = kEBucketLength (this->bucket, this->p, this->sugar, c);
     else
-      cs=nSize(coef);
-    #ifdef HAVE_COEF_BUCKETS
-    if (bucket->coef[0]!=NULL)
-    {
-      if (rField_is_Q(currRing))
-      {
-        int modifier=QlogSize(pGetCoeff(bucket->coef[0]));
-        cs+=modifier;
-      }
-      else
-      {
-        int modifier=nSize(pGetCoeff(bucket->coef[0]));
-        cs*=modifier;}
-    }
-    #endif
-    //FIXME:not quadratic
-    wlen_type erg=kEBucketLength(this->bucket,this->p,this->sugar,c);
-    //erg*=cs;//for quadratic
-    erg*=cs;
-    if (TEST_V_COEFSTRAT)
-        erg*=cs;
-    //return cs*kEBucketLength(this->bucket,this->p,c);
-    return erg;
-      }
-      s=kSBucketLength(bucket,NULL);
-    }
-    else
-    {
-      if(c->eliminationProblem)
-  //if (false)
-  s=kEBucketLength(this->bucket,this->p,this->sugar,c);
-      else s=bucket_guess(bucket);
-    }
-    return s;
-}
-
-#if 0 //currently unused
-static void finalize_reduction_step(reduction_step* r)
+      s = bucket_guess (bucket);
+  }
+  return s;
+}
+
+#if 0				//currently unused
+static void
+finalize_reduction_step (reduction_step * r)
 {
   delete r;
 }
 #endif
-#if 0 //currently unused
-static int LObject_better_gen(const void* ap, const void* bp)
-{
-  LObject* a=*(LObject**)ap;
-  LObject* b=*(LObject**)bp;
-  return(pLmCmp(a->p,b->p));
-}
-#endif
-static int red_object_better_gen(const void* ap, const void* bp)
-{
-  return(pLmCmp(((red_object*) ap)->p,((red_object*) bp)->p));
-}
-
-#if 0 //currently unused
-static int pLmCmp_func_inverted(const void* ap1, const void* ap2)
-{
-  poly p1,p2;
-  p1=*((poly*) ap1);
-  p2=*((poly*)ap2);
-  return -pLmCmp(p1,p2);
-}
-#endif
-
-int tgb_pair_better_gen2(const void* ap,const void* bp)
-{
-  return(-tgb_pair_better_gen(ap,bp));
-}
-int kFindDivisibleByInS_easy(kStrategy strat,const red_object & obj)
+#if 0				//currently unused
+static int
+LObject_better_gen (const void *ap, const void *bp)
+{
+  LObject *a = *(LObject **) ap;
+  LObject *b = *(LObject **) bp;
+  return (pLmCmp (a->p, b->p));
+}
+#endif
+static int
+red_object_better_gen (const void *ap, const void *bp)
+{
+  return (pLmCmp (((red_object *) ap)->p, ((red_object *) bp)->p));
+}
+
+#if 0				//currently unused
+static int
+pLmCmp_func_inverted (const void *ap1, const void *ap2)
+{
+  poly p1, p2;
+  p1 = *((poly *) ap1);
+  p2 = *((poly *) ap2);
+  return -pLmCmp (p1, p2);
+}
+#endif
+
+int
+tgb_pair_better_gen2 (const void *ap, const void *bp)
+{
+  return (-tgb_pair_better_gen (ap, bp));
+}
+
+int
+kFindDivisibleByInS_easy (kStrategy strat, const red_object & obj)
 {
   int i;
-  long not_sev=~obj.sev;
-  poly p=obj.p;
-  for(i=0;i<=strat->sl;i++)
-  {
-    if (pLmShortDivisibleBy(strat->S[i],strat->sevS[i],p,not_sev))
+  long not_sev = ~obj.sev;
+  poly p = obj.p;
+  for (i = 0; i <= strat->sl; i++)
+  {
+    if (pLmShortDivisibleBy (strat->S[i], strat->sevS[i], p, not_sev))
       return i;
   }
   return -1;
 }
-int kFindDivisibleByInS_easy(kStrategy strat,poly p, long sev)
+
+int
+kFindDivisibleByInS_easy (kStrategy strat, poly p, long sev)
 {
   int i;
-  long not_sev=~sev;
-  for(i=0;i<=strat->sl;i++)
-  {
-    if (pLmShortDivisibleBy(strat->S[i],strat->sevS[i],p,not_sev))
+  long not_sev = ~sev;
+  for (i = 0; i <= strat->sl; i++)
+  {
+    if (pLmShortDivisibleBy (strat->S[i], strat->sevS[i], p, not_sev))
       return i;
   }
   return -1;
 }
-static int posInPairs (sorted_pair_node**  p, int pn, sorted_pair_node* qe,slimgb_alg* c,int an=0)
-{
-  if(pn==0) return 0;
-
-  int length=pn-1;
+
+static int
+posInPairs (sorted_pair_node ** p, int pn, sorted_pair_node * qe,
+	    slimgb_alg * c, int an = 0)
+{
+  if (pn == 0)
+    return 0;
+
+  int length = pn - 1;
   int i;
   //int an = 0;
-  int en= length;
-
-  if (pair_better(qe,p[en],c))
-    return length+1;
-
-  while(1)
-    {
-      //if (an >= en-1)
-      if(en-1<=an)
-      {
-        if (pair_better(p[an],qe,c)) return an;
-        return en;
-      }
-      i=(an+en) / 2;
-        if (pair_better(p[i],qe,c))
-          en=i;
-      else an=i;
-    }
-}
-
-static BOOLEAN  ascending(int* i,int top)
-{
-  if(top<1) return TRUE;
-  if(i[top]<i[top-1]) return FALSE;
-  return ascending(i,top-1);
-}
-
-sorted_pair_node**  spn_merge(sorted_pair_node** p, int pn,sorted_pair_node **q, int qn,slimgb_alg* c)
+  int en = length;
+
+  if (pair_better (qe, p[en], c))
+    return length + 1;
+
+  while (1)
+  {
+    //if (an >= en-1)
+    if (en - 1 <= an)
+    {
+      if (pair_better (p[an], qe, c))
+	return an;
+      return en;
+    }
+    i = (an + en) / 2;
+    if (pair_better (p[i], qe, c))
+      en = i;
+    else
+      an = i;
+  }
+}
+
+static BOOLEAN
+ascending (int *i, int top)
+{
+  if (top < 1)
+    return TRUE;
+  if (i[top] < i[top - 1])
+    return FALSE;
+  return ascending (i, top - 1);
+}
+
+sorted_pair_node **
+spn_merge (sorted_pair_node ** p, int pn, sorted_pair_node ** q, int qn,
+	   slimgb_alg * c)
 {
   int i;
-  int* a= (int*) omalloc(qn*sizeof(int));
+  int *a = (int *) omalloc (qn * sizeof (int));
 //   int mc;
 //   PrintS("Debug\n");
@@ -712,137 +806,152 @@
 //     PrintS("\n");
 // }
-  int lastpos=0;
-  for(i=0;i<qn;i++)
-  {
-    lastpos=posInPairs(p,pn,q[i],c, si_max(lastpos-1,0));
+  int lastpos = 0;
+  for (i = 0; i < qn; i++)
+  {
+    lastpos = posInPairs (p, pn, q[i], c, si_max (lastpos - 1, 0));
     //   cout<<lastpos<<"\n";
-    a[i]=lastpos;
-  }
-  if((pn+qn)>c->max_pairs)
-  {
-    p=(sorted_pair_node**) omrealloc(p,2*(pn+qn)*sizeof(sorted_pair_node*));
-    c->max_pairs=2*(pn+qn);
-  }
-  for(i=qn-1;i>=0;i--)
+    a[i] = lastpos;
+  }
+  if ((pn + qn) > c->max_pairs)
+  {
+    p =
+      (sorted_pair_node **) omrealloc (p,
+				       2 * (pn +
+					    qn) *
+				       sizeof (sorted_pair_node *));
+    c->max_pairs = 2 * (pn + qn);
+  }
+  for (i = qn - 1; i >= 0; i--)
   {
     size_t size;
-    if(qn-1>i)
-      size=(a[i+1]-a[i])*sizeof(sorted_pair_node*);
+    if (qn - 1 > i)
+      size = (a[i + 1] - a[i]) * sizeof (sorted_pair_node *);
     else
-      size=(pn-a[i])*sizeof(sorted_pair_node*); //as indices begin with 0
-    memmove (p+a[i]+(1+i), p+a[i], size);
-    p[a[i]+i]=q[i];
-  }
-  omfree(a);
+      size = (pn - a[i]) * sizeof (sorted_pair_node *);	//as indices begin with 0
+    memmove (p + a[i] + (1 + i), p + a[i], size);
+    p[a[i] + i] = q[i];
+  }
+  omfree (a);
   return p;
 }
 
-static BOOLEAN trivial_syzygie(int pos1,int pos2,poly bound,slimgb_alg* c)
-{
-  poly p1=c->S->m[pos1];
-  poly p2=c->S->m[pos2];
-
-  if (pGetComp(p1) > 0 || pGetComp(p2) > 0)
+static BOOLEAN
+trivial_syzygie (int pos1, int pos2, poly bound, slimgb_alg * c)
+{
+  poly p1 = c->S->m[pos1];
+  poly p2 = c->S->m[pos2];
+
+  if (pGetComp (p1) > 0 || pGetComp (p2) > 0)
     return FALSE;
   int i = 1;
-  poly m=NULL;
-  poly gcd1=c->gcd_of_terms[pos1];
-  poly gcd2=c->gcd_of_terms[pos2];
-
-  if((gcd1!=NULL) && (gcd2!=NULL))
-  {
-    gcd1->next=gcd2; //may ordered incorrect
-    m=gcd_of_terms(gcd1,c->r);
-    gcd1->next=NULL;
-  }
-  if (m==NULL)
-  {
-     loop
-      {
-  if (pGetExp(p1, i)+ pGetExp(p2, i) > pGetExp(bound,i))   return FALSE;
-  if (i == pVariables)
-  {
-    //PrintS("trivial");
+  poly m = NULL;
+  poly gcd1 = c->gcd_of_terms[pos1];
+  poly gcd2 = c->gcd_of_terms[pos2];
+
+  if ((gcd1 != NULL) && (gcd2 != NULL))
+  {
+    gcd1->next = gcd2;		//may ordered incorrect
+    m = gcd_of_terms (gcd1, c->r);
+    gcd1->next = NULL;
+  }
+  if (m == NULL)
+  {
+    loop
+    {
+      if (pGetExp (p1, i) + pGetExp (p2, i) > pGetExp (bound, i))
+	return FALSE;
+      if (i == pVariables)
+      {
+	//PrintS("trivial");
+	return TRUE;
+      }
+      i++;
+    }
+  }
+  else
+  {
+    loop
+    {
+      if (pGetExp (p1, i) - pGetExp (m, i) + pGetExp (p2, i) >
+	  pGetExp (bound, i))
+      {
+	pDelete (&m);
+	return FALSE;
+      }
+      if (i == pVariables)
+      {
+	pDelete (&m);
+	//PrintS("trivial");
+	return TRUE;
+      }
+      i++;
+    }
+  }
+}
+
+//! returns position sets w as weight
+int
+find_best (red_object * r, int l, int u, wlen_type & w, slimgb_alg * c)
+{
+  int best = l;
+  int i;
+  w = r[l].guess_quality (c);
+  for (i = l + 1; i <= u; i++)
+  {
+    wlen_type w2 = r[i].guess_quality (c);
+    if (w2 < w)
+    {
+      w = w2;
+      best = i;
+    }
+  }
+  return best;
+}
+
+void
+red_object::canonicalize ()
+{
+  kBucketCanonicalize (bucket);
+}
+
+BOOLEAN
+good_has_t_rep (int i, int j, slimgb_alg * c)
+{
+  assume (i >= 0);
+  assume (j >= 0);
+  if (has_t_rep (i, j, c))
     return TRUE;
-  }
-  i++;
-      }
-  }
-  else
-  {
-    loop
-      {
-  if (pGetExp(p1, i)-pGetExp(m,i) + pGetExp(p2, i) > pGetExp(bound,i))  {
-    pDelete(&m);
-    return FALSE;}
-  if (i == pVariables)
-  {
-    pDelete(&m);
-    //PrintS("trivial");
-    return TRUE;
-  }
-  i++;
-      }
-  }
-}
-
-//! returns position sets w as weight
-int find_best(red_object* r,int l, int u, wlen_type &w, slimgb_alg* c)
-{
-  int best=l;
+  //poly lm=pOne();
+  assume (c->tmp_lm != NULL);
+  poly lm = c->tmp_lm;
+
+  pLcm (c->S->m[i], c->S->m[j], lm);
+  pSetm (lm);
+  assume (lm != NULL);
+  //int deciding_deg= pTotaldegree(lm);
+  int *i_con = make_connections (i, j, lm, c);
+  //p_Delete(&lm,c->r);
+
+  for (int n = 0; ((n < c->n) && (i_con[n] >= 0)); n++)
+  {
+    if (i_con[n] == j)
+    {
+      now_t_rep (i, j, c);
+      omfree (i_con);
+      return TRUE;
+    }
+  }
+  omfree (i_con);
+
+  return FALSE;
+}
+
+BOOLEAN
+lenS_correct (kStrategy strat)
+{
   int i;
-  w=r[l].guess_quality(c);
-  for(i=l+1;i<=u;i++)
-  {
-    wlen_type w2=r[i].guess_quality(c);
-    if(w2<w)
-    {
-      w=w2;
-      best=i;
-    }
-  }
- return best;
-}
-
-void red_object::canonicalize()
-{
-  kBucketCanonicalize(bucket);
-}
-
-BOOLEAN good_has_t_rep(int i, int j,slimgb_alg* c)
-{
-  assume(i>=0);
-    assume(j>=0);
-  if (has_t_rep(i,j,c)) return TRUE;
-  //poly lm=pOne();
-  assume (c->tmp_lm!=NULL);
-  poly lm=c->tmp_lm;
-
-  pLcm(c->S->m[i], c->S->m[j], lm);
-  pSetm(lm);
-  assume(lm!=NULL);
-  //int deciding_deg= pTotaldegree(lm);
-  int* i_con =make_connections(i,j,lm,c);
-  //p_Delete(&lm,c->r);
-
-  for (int n=0;((n<c->n) && (i_con[n]>=0));n++)
-  {
-    if (i_con[n]==j)
-    {
-      now_t_rep(i,j,c);
-      omfree(i_con);
-      return TRUE;
-    }
-  }
-  omfree(i_con);
-
-  return FALSE;
-}
-BOOLEAN lenS_correct(kStrategy strat)
-{
-  int i;
-  for(i=0;i<=strat->sl;i++)
-  {
-    if (strat->lenS[i]!=pLength(strat->S[i]))
+  for (i = 0; i <= strat->sl; i++)
+  {
+    if (strat->lenS[i] != pLength (strat->S[i]))
       return FALSE;
   }
